/**
 *    author:  tourist
 *    created: 24.10.2019 01:45:11       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    a[i] %= m;
  }
  const int M = (int) 4e7 + 1;
  auto Shift = [&](const bitset<M>& x, int y) {
    return (x >> y) | (x << (m - y));
  };
  vector<bitset<M>> dp(n + 1);
  dp[0][0] = 1;
  for (int i = 0; i < n; i++) {
    dp[i + 1] = Shift(dp[i], a[i]) | Shift(dp[i], m - a[i]);
    if (dp[i + 1][0]) {
      vector<int> L, R;
      int s = 0;
      for (int j = i; j >= 0; j--) {
        if (dp[j][(s + a[j]) % m]) {
          L.push_back(j);
          s = (s + a[j]) % m;
        } else {
          if (dp[j][(s + m - a[j]) % m]) {
            R.push_back(j);
            s = (s + m - a[j]) % m;
          } else {
            assert(dp[j][s]);
          }
        }
      }
      cout << L.size() << '\n';
      for (int v : L) cout << v + 1 << " ";
      cout << '\n';
      cout << R.size() << '\n';
      for (int v : R) cout << v + 1 << " ";
      cout << '\n';
      return 0;
    }
    dp[i + 1] |= dp[i];
  }
  cout << -1 << '\n';
  return 0;
}
