// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
  
#include <bits/stdc++.h>
  
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
  
typedef long long ll;
typedef long double ld;
  
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
  
using namespace std;
  
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
  
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
  
    fastIO;
  
    int n, m;
    cin >> n;
  
    string cor;
    cin >> cor;
  
    cin >> m;
  
    vector <string> arr(m);
    for (int i = 0; i < m; i++)
        cin >> arr[i];
 
    vector < vector<bool> > kek(m, vector<bool>(m));
  
    vector < pair<int, int> > ans;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            if (i == j)
                continue;
            int cntt = 0, cntf = 0;
            int at = 0, af = 0;
            for (int k = 0; k < n; k++) {
                if (arr[i][k] == cor[k])
                    at++;
                else
                    af++;
                if (arr[i][k] == cor[k] && arr[i][k] == arr[j][k]) {
                    cntt++;
                }
                if (arr[i][k] != cor[k] && arr[i][k] == arr[j][k]) {
                    cntf++;
                }
            }
            if (cntt * 2 > at && cntf * 2 > af)
                kek[i][j] = true;
        }
    }
 
    for (int i = 0; i < m; i++) {
        for (int j = i + 1; j < m; j++) {
            if (kek[i][j] && kek[j][i])
                ans.push_back(make_pair(i, j));
        }
    }
  
    cout << (int)ans.size() << '\n';
    for (int i = 0; i < (int)ans.size(); i++) {
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << '\n';
    }
      
    return 0;
}
