#include <bits/stdc++.h>

using namespace std;

struct Event {
  long long value;
  int time;
};

int main() {
  int n, m;
  long long s;
  cin >> n >> m >> s;
  vector<Event> events;
  for (int i = 0; i < n; i++) {
    long long count;
    int from, to;
    cin >> count >> from >> to;
    if (count < 0) {
      events.push_back({count, from});
    } else {
      events.push_back({count, to});
    }
  }
  sort(events.begin(), events.end(), [&](Event a, Event b) {
    if (a.time != b.time) {
      return a.time < b.time;
    }
    return a.value < b.value;
  });
  for (Event& e : events) {
    s += e.value;
    if (s < 0) {
      cout << "YES\n";
      return 0;
    }
  }
  cout << "NO\n";
}
