#include "testlib.h"
#include <iostream>
#include <unordered_set>

using namespace std;

struct edge{
    int v, w; char c;
    edge(){}
    edge(int v, int w, char c) : v(v), w(w), c(c) {}
};


int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int red = atoi(argv[2]);
    int black = atoi(argv[3]);
    int qs = atoi(argv[4]);

    vector <edge> all;
    for (int i = 0; i < n * n; i++) {
        int w = i % n, v = i / n;
        if (v < w) {
            if (rnd.next(n * n) < red) {
                all.emplace_back(v, w, 'T');
            }
            if (rnd.next(n * n) < black) {
                all.emplace_back(v, w, 'F');
            }
        }
    }
    shuffle(all.begin(), all.end());
    cout << n << ' ' << 0 << ' ' << 0 << '\n';
    cout << all.size() + qs << '\n';
    vector <int> type;
    for (int i = 0; i < qs; i++) type.push_back(1);
    for (int i = 0; i < all.size(); i++) type.push_back(0);
    int cnt = 0;
    shuffle(type.begin(), type.end());
    for (int i : type) {
        if (i) {
            cout << '?' << ' ' << rnd.next(n) + 1 << '\n';
        } else {
            if (rnd.next(2) == 1) swap(all[cnt].v, all[cnt].w);
            cout << all[cnt].c << ' ' << all[cnt].v + 1 << ' ' << all[cnt].w + 1 << '\n';
            cnt++;
        }
    }
    return 0;
}