#include "testlib.h"
#include <iostream>
#include <unordered_set>

using namespace std;

struct edge{
    int v, w; char c;
    edge(){}
    edge(int v, int w, char c) : v(v), w(w), c(c) {}
};

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    vector <edge> af, at;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            af.emplace_back(i, j, 'F');
            at.emplace_back(i, j, 'T');
        }
    }
    int m = rnd.next(0, n * (n - 1) / 2 + 1);
    int k = rnd.next(0, n * (n - 1) / 2 + 1);

    shuffle(af.begin(), af.end());
    shuffle(at.begin(), at.end());

    cout << n << ' ' << m << ' ' << k << '\n';
    int cnt = 0;
    for (int i = 0; i < m; i++) {
        if (rnd.next(2) == 1) swap(af.back().v, af.back().w);
        cout << af.back().v + 1 << ' ' << af.back().w + 1 << '\n';
        af.pop_back();
    }
    for (int i = 0; i < k; i++) {
        if (rnd.next(2) == 1) swap(at.back().v, at.back().w);
        cout << at.back().v + + 1 << ' ' << at.back().w + 1<< '\n';
        at.pop_back();
    }
    vector <edge> all = af;
    for (auto i : at) all.push_back(i);
    shuffle(all.begin(), all.end());
    int q = 100000;
    cout << q << '\n';
    while (!all.empty()) {
        q--;
        if (rnd.next(2) == 1) swap(all.back().v, all.back().w);
        cout << all.back().c << ' ' << all.back().v+ 1  << ' ' << all.back().w+ 1  << '\n';
        all.pop_back();
    }
    int cur = 1;
    for (int i = 0; i < q; i++) {
        cout << '?' << ' ' << cur++ << '\n';
        if (cur > n) cur = 1;
    }
    return 0;
}