#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n;
int a[20];

int readAndCheckAnswer(InStream& in) {
	int m = in.readInt(1, 360);
	vector<int> cuts;
	for (int i = 0; i < m; i++)
	{
		int x = in.readInt(0, 359);
		int y = in.readInt(0, 1);
		cuts.push_back(x);
		if (y)
			cuts.push_back((x + 180) % 360);
	}
	sort(cuts.begin(), cuts.end());
	vector<int> angles;
	for (int i = 0; i + 1 < (int)cuts.size(); i++)
		angles.push_back(cuts[i + 1] - cuts[i]);
	angles.push_back(cuts[0] + 360 - cuts.back());
	sort(angles.begin(), angles.end());
	int q = 0;
	for (int i: angles)
	{
		if (i == a[q])
		{
			q++;
			if (q == n)
				return m;
		}
	}
	quitf(_wa, "Wrong cuts");
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    
    n = inf.readInt();
    for (int i = 0; i < n; i++)
	   	a[i] = inf.readInt();
	sort(a, a + n);
	int j_ans = readAndCheckAnswer(ans);
	int p_ans = readAndCheckAnswer(ouf);
	if (p_ans > j_ans)
		quitf(_wa, "too many cuts");
	else if (p_ans < j_ans)
		quitf(_fail, "participant has %d cuts, jury %d cuts", p_ans, j_ans);
    quitf(_ok, "%d cuts", p_ans);
}