#include <bits/stdc++.h>

using namespace std;

const int N = 300005;

int f[N];

int sum(int v) {
    int res = 0;
    while (v >= 0) {
        res += f[v];
        v = v & (v + 1);
        v--;
    }
    return res;
}

int sum(int l, int r) {
    if (l > r) {
        return 0;
    }
    return sum(r) - sum(l - 1);
}

void add(int v) {
    while (v < N) {
        f[v]++;
        v = v | (v + 1);
    }
}

int n;
vector<int> a;
vector<int> pos;
vector<long long> perm;
const long long MOD = 1000000000 + 7;

int suf(int mx) {
    int cur = pos[mx];
    int prev = pos[mx + 1];
    int cnt = 0;
    if (cur < prev) {
        cnt = prev - cur - 1 - sum(cur + 1, prev - 1);
    } else {
        cnt = n - 1 - cur - sum(cur + 1, n - 1);
        cnt += prev - sum(0, prev - 1);
    }
    add(pos[mx]);
    return cnt;
}

long long get(int mx) {
    if (mx == 0) {
        perm[mx] = 0;
        return 0;
    }
    long long res = (suf(mx) + (mx + 1ll) * get(mx - 1)) % MOD;
    perm[mx] = res;
    return res;
}

long long ans(int mx) {
    if (mx == 0) {
        return 0;
    }
    long long res = (suf(mx) + ans(mx - 1) + (mx + 1LL) * perm[mx - 1]) % MOD;
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef HOME
    freopen("in.txt", "r", stdin);
#else
    //    freopen("cnf.in", "r", stdin);
    //    freopen("cnf.out", "w", stdout);
#endif
    cin >> n;
    if (n == 1) {
        cout << 1 << endl;
        return 0;
    }
    a.resize(n);
    pos.resize(n);
    perm.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        pos[a[i]] = i;
    }
    add(pos[n - 1]);
    get(n - 2);
    for (int i = 0; i < n; i++) {
        f[i] = 0;
    }
    add(pos[n - 1]);
    cout << (ans(n - 2) + n - pos[n - 1] + 1LL * n * perm[n - 2]) % MOD;
}